//<t>   Parse Maximus' FILEAREA.CTL and FILE_ID.DIZ info from all archives

//      Creates a top-level index, and individual index pages in each
//      file area directory.


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_ansi.h"
#include"gd_kb.h"
#include"gd_scrn.h"
#include"ms_struc.h"
#include<search.h>


#define pgVERS_ "V2.00"
#define pgTITL_ "Create HTML file index pages using Maximus' FILEAREA.CTL"
#define pgCOPR_ "1997"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define MAXFLS  10000                           // max number of files
#define BUFSIZE 10000
FILE    *fMaxIn, *fTop, *fDizOut, *fDizIn, *fFilesBBS, *fFilesTXT, *fMaster,
        *fLog, *fBat, *fChtml ;
UCHAR   *pcmd, MaximusFAdesc[FS_LEN*2], cmd[256],
        fl_1[FS_LEN], fl_2[FS_LEN], fl_3[FS_LEN], fl_bat[FS_LEN]="c:\\$$$.bat",
        fl_fbbs[FS_LEN], fl_ftxt[FS_LEN], fl_log[FS_LEN], fl_master[FS_LEN],
        fl_ziplog[]="zip$log.txt", fl_Chtml[FS_LEN], sChtml[FS_LEN]="fcount.htm",
        iniFile[FS_LEN]="", sCDname[128]="CD-ROM File Index",
        sColAlink[11]="FF0000", sColBG[11]="33CCFF", sColLink[11]="0000EE",
        sColText[11]="000000", sColVlink[11]="551A8B",
        sDLtext[81]="Download", sFAdesc[121], sFAdir[FS_LEN], sFAname[41],
        sFDdesc[121]="", sFDname[41]="", sFilName[FS_LEN], sFileCase[21]="",
        sFileDateOut[31], sFileDate[31], sFileName[FS_LEN], sFileTimeOut[31],
        sFilesBBS[FS_LEN], sFilesTXT[FS_LEN], sFont[61]="Verdana",
        sInFile[FS_LEN], sLogSdate[21], sLogSday[21], sLogStime[21],
        sMaxHome[FS_LEN], sSiteBG[256]="", sSite[256]="", sSize[21],
        sTopDir[FS_LEN], sTopName[FS_LEN]="index.htm",
        tmplocation[FS_LEN], work[BUFSIZE+1] ;
long    found = 0L, cfound = 0L, nFileCount = 0 ;
int     ft_entries=0, attrib=REGULAR_FILES ;
struct  find_t dta ;
static  char    *ftable[MAXFLS+1] ;
STRING  dizFile = "FILE_ID.DIZ" ;
char    origdir[FS_LEN], sFileMask[FS_LEN] = "*.*" ;
INT32   sys_yyyymmdd ;
BOOL    ynFilesBBS = FALSE, ynFilesTXT = FALSE, ynMaster = FALSE ;
int     nLDI = 0 ;
char    cLDC = ' ' ;
UINT32  lFileDateOut, lFileTimeOut ;


union   fileDateUnion
{
        ms_date_t dt ;
        unsigned ndt ;
}       fldate ;


void    do_help( void )
{
    logon(1);
    fprintf( stderr, "\nMake sure %s.INI is available for processing...\n",
            get_global_program_name() );
    exit( GD_ERROR_HELP );
}


void    check_for_key( void )
{
    if ( kbhit() )
    {
        if ( getch() == ESCAPE )                // Escape cancels
        {
            fprintf( stderr, "\nCancelled by user\a\n" );
            exit( GD_ERROR_USER_CANCEL );
        }
    }
}


int     qs_compare( const char **arg1, const char **arg2 )
{
    return( _stricmp( *arg1, *arg2 ) );
}


void    ftable_update( char fname[] )
{
    static char fu_drv[FS_LEN], fu_dir[FS_LEN], fu_name[FS_LEN], fu_ext[FS_LEN] ;

    _splitpath( fname, fu_drv, fu_dir, fu_name, fu_ext );
    if ( ! (
            st_eq(fu_ext,".zip")
            ||
            st_eq(fu_ext,".rar")
            ||
            st_eq(fu_ext,".arj")
       ) )
    {
        if ( ! st_eq(fname, sFilesBBS) &&
             ! st_eq(fname, sFilesTXT) &&
             ! st_eq(fname, sFilName)  &&
             ! st_eq(fname, fl_ziplog) )
            fprintf( fLog, "\tSkipping non-archive %s\n", fname );
        return ;
    }

    found += 1L ;
    strcpy( cmd, fname );
    st_reduce_spaces( cmd );
    st_trim( cmd );
    strupr( cmd );
    if ( strlen(cmd) )
    {
        if ( ft_entries < MAXFLS )
        {
            ftable[ft_entries] = _strdup(cmd);
            if ( ftable[ft_entries] == NULL )
                exit( GD_ERROR_NO_MEMORY );
            ft_entries += 1 ;
        }
        else
        {
            fprintf( fLog, "\tTOO MANY ENTRIES IN THE FILE TABLE: %s SKIPPED\n", fname );
        }
    }
}


STRING  l_r_title( STRING l, STRING r, STRING t )
{
    static UCHAR sOut[82] ;
    int         i, x ;

    ST_CPY( sOut, t );
    x = 2;  i = 0;
    while ( l[i] != EOS )
        sOut[x++] = l[i++] ;
    x = 77 - strlen(r);  i = 0 ;
    while ( r[i] != EOS )
        sOut[x++] = r[i++] ;
    return( sOut );
}


void    set_file_information( FILE *f, STRING filename )
{
    fclose( f );
    if ( f = fopen( filename, "rb+" ) )         // set file date/time
    {
        SetFileInfo( f, lFileDateOut, lFileTimeOut );
        fclose( f );
    }
    SetAttrib( filename, 0, 0, 0, -1 );         // turn off archive attribute
    fclose( f );
}


void    process_diz( STRING fname )                                     //~~~
{
    register int x ;
    int         rCount = 0 ;
    BOOL        ynLineTooLong = FALSE, ynTooManyLines = FALSE ;
    static      UCHAR sTmp[512], sToken[21] ;

    if ( ( fDizIn = fopen( fname, "r" ) ) == NULL )
        return ;

    st_trim( sFileName );
    st_trim( sFileDate );
    strcpy( work, sFileName );
    strlwr( work );                             // by default lower case
    if ( sFileCase[0] == 'U' )
        strupr( work );                         // uppercase
    if ( sFileCase[0] == 'X' )
    {                                           // mixed case
        if ( islower( work[0] ) )
            work[0] = toupper( work[0] );
    }

    if ( ynMaster )
        fprintf( fMaster, "%-13s%s %s ", work, sFileDate, sSize );
    if ( ynFilesTXT )
        fprintf( fFilesTXT, "\n%-13s%s %s ", work, sFileDate, sSize );

    fprintf( fDizOut, "<font face=\"%s\" size=\"3\"><strong>%s</strong> </font>\n"
                      "<font face=\"%s\" size=\"2\">... %s ... %s </font>\n"
                      "<font face=\"%s\" size=\"1\"><strong>&nbsp;&nbsp;&nbsp;\n",
                      sFont, sFileName, sFont, sFileDate, sSize, sFont );
    if ( strlen(sDLtext) )
        fprintf( fDizOut, "<a HREF=\"%s\">%s</a>\n", work, sDLtext );
    fprintf( fDizOut, "</strong></font><div align=\"right\">\n"
                      "<table border=\"0\" width=\"90%%\" cellpadding=\"2\" cellspacing=\"0\"><tr>\n"
                      "<td width=\"100%%\"><font color=\"#FFFFFF\"><strong><font face=\"%s\" size=\"2\">\n", sFont );

    while ( fgets( work, (sizeof(work)-1), fDizIn ) )
    {
        check_for_key();
        st_rtrim( work );
        if ( strlen(work) )
        {
            if ( ynFilesTXT )
            {
                if ( rCount )                   // rCount = 0 for first record...
                    fprintf( fFilesTXT, "%33s", "" );
                fprintf( fFilesTXT, "%s\n", work );
            }

            if ( ynFilesBBS )
            {
                if ( rCount )                   // rCount = 0 for first record...
                {
                    if ( nLDI > 0 )
                        fprintf( fFilesBBS, "%*s", nLDI, "" );
                    fprintf( fFilesBBS, "%c", cLDC );
                }
                fprintf( fFilesBBS, "%s\n", work );
            }

            if ( ynMaster )
            {
                if ( rCount )                   // rCount = 0 for first record...
                    fprintf( fMaster, "%33s", "" );
                fprintf( fMaster, "%s\n", work );
            }

            ST_CPY( sTmp, work );
            work[0] = EOS ;
            x = 0 ;
            while ( sTmp[x] != EOS )
            {
                strcat( work, ht_char2str( sTmp[x], sToken ) );
                x ++ ;
            }
            fprintf( fDizOut, "  %s<br>\n", work );
            rCount ++ ;
        }
    }
    fprintf( fDizOut, "</font></strong></td></tr></table></div> &nbsp;<br>\n" );

    if ( ynMaster )
    {
        fprintf( fMaster, "\n" );
        if ( ! rCount )
            fprintf( fMaster, "\n" );
    }

    fclose( fDizIn );
}


void    process_file( char fname[], int iCount, int iTotal )            //~~~
{
    static int  done ;
    static char fu_drv[FS_LEN], fu_dir[FS_LEN], fu_name[FS_LEN], fu_ext[FS_LEN] ;

    _splitpath( fname, fu_drv, fu_dir, fu_name, fu_ext );

    cfound += 1L ;
    fprintf( stderr, "\r%-40s\r%d of %d: %s", "", iCount, iTotal, fname );
    strupr( fname );
    strcpy( sFileName, fname );

    sprintf( work, "%s", fname );
    if ( ynFilesBBS )
        fprintf( fFilesBBS, "%-13s", fname );
    done = _dos_findfirst( work, attrib, &dta );
    if ( done )
    {
        fprintf( fDizOut, "<<<ERROR>>> file is now missing!\n" );
        return ;
    }

    fldate.ndt = dta.wr_date ;                  // file date
    MSdate2text( fldate.dt, sFileDate );
    if ( sFileDate[0] == SPACE )
         sFileDate[0] = '0' ;

    if ( dta.size > 2047 )
    {
        dta.size /= SZ_kBYTE ;
        Format_UINT32( (UINT32) dta.size, work );
        sprintf( sSize, "%6sK", work );
    }
    else
    {
        Format_UINT32( (UINT32) dta.size, work );
        sprintf( sSize, "%7s", work );
    }

    sprintf( work, "%s\\%s", tmplocation, dizFile );
    fl_delete( work );                          // get rid of old file first
    if ( st_eq(fu_ext, ".arj") )
        fl_delete( dizFile );

    check_for_key();

    ST_CLR( work );
    if ( st_eq(fu_ext, ".zip") )
    {
        sprintf( work, "pkunzip %s %s %s >nul", fname, dizFile, tmplocation );
        fprintf( fBat, " echo Testing ZIP archive %s in %s\n"
                       " call zipcmt$u %s\n"
                       " pkunzip -t %s >>%s\n",
                       fname, sFAdir,
                       fname,
                       fname, fl_ziplog );
    }
    else
    if ( st_eq(fu_ext, ".rar") )
        sprintf( work, "unrar e /c- %s %s %s\\ >nul", fname, dizFile, tmplocation );
    else
    if ( st_eq(fu_ext, ".arj") )
        sprintf( work, "arj e -y %s %s -w%s >nul", fname, dizFile, tmplocation );
    if ( strlen(work) )
        system( work );
    if ( st_eq(fu_ext, ".arj") )                // arj puts file in current directory
    {
        sprintf( work, "copy %s %s >nul", dizFile, tmplocation );
        system( work );
    }

    sprintf( work, "%s\\%s", tmplocation, dizFile );
    if ( ! fl_exist( work ) )
    {
        if ( ynFilesTXT )
            fprintf( fFilesTXT, "\n" );
        if ( ynFilesBBS )
            fprintf( fFilesBBS, "\n" );
        return ;
    }
    process_diz( work );                        // process diz file
    nFileCount ++ ;                             // file count within directory
}


void    fcount_head( FILE *out )                                        //~~~
{
    UCHAR       bg[300]="" ;

    if ( strlen(sSiteBG) )
        sprintf( bg, "BACKGROUND=\"%s\"", sSiteBG );

    fprintf( out, "<HTML>\n<HEAD>\n <META NAME=\"GENERATOR\" CONTENT=\"%s %s\">\n"
                  " <META NAME=\"Author\" CONTENT=\"Gerry Danen\">\n"
                  " <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n"
                  " <TITLE>%s: File Count\n </TITLE>\n</HEAD>\n"
                  "<BODY %s BGPROPERTIES=\"fixed\" TEXT=\"#FFFF00\" LINK=\"#FF0000\" VLINK=\"#FF00FF\" ALINK=\"#FF0000\">\n\n",
                  pgm_name, pgm_vers, sCDname, bg );

    fprintf( out, "<div align=\"center\"><center>\n<table border=\"5\" width=\"100%%\" bgcolor=\"#FF0000\">\n"
                  " <tr>\n<td width=\"100%%\"><p align=\"center\"><font face=\"%s\" color=\"#FFFF00\" size=\"6\">\n"
                  "  <strong>%s<br>File Count by Directory</strong></font></td>\n"
                  " </tr>\n</table>\n</center></div><small><small><p>&nbsp;</p></small></small>\n\n", sFont, sCDname );

    fprintf( out, "<div align=\"center\"><center>\n"
                  "<table border=\"1\" bgcolor=\"#000080\" width=\"100%%\">\n"
                  " <tr VALIGN=\"bottom\">\n"
                  "  <td ALIGN=\"left\" width=\"25%%\"><font face=\"%s\" size=\"2\" color=\"#FFFFFF\">\n"
                  "   <strong>Directory</strong></font></td>\n"
                  "  <td ALIGN=\"left\" width=\"60%%\"><font face=\"%s\" size=\"2\" color=\"#FFFFFF\">\n"
                  "   <strong>Description</strong></font></td>\n"
                  "  <td ALIGN=\"right\" width=\"15%%\"><font face=\"%s\" size=\"2\" color=\"#FFFFFF\">\n"
                  "   <strong># of files</strong></font></td>\n </tr>\n\n",
                  sFont, sFont, sFont );
}


void    fcount_end( FILE *out )                                         //~~~
{
    fprintf( out, "\n</table>\n</center></div>\n\n"
                  "<p><font face=\"%s\" size=\"1\"><strong>Created on %s</strong></font></p>\n\n"
                  "</body>\n</html>\n",
                  sFont, sFileDateOut );
}


void    output_head( FILE *out, STRING tit )                            //~~~
{
    UCHAR       bg[300]="" ;

    if ( strlen(sSiteBG) )
        sprintf( bg, "BACKGROUND=\"%s\"", sSiteBG );

    fprintf( out, "<HTML>\n<HEAD>\n"
                  " <META NAME=\"GENERATOR\" CONTENT=\"%s %s\">\n"
                  " <META NAME=\"Author\" CONTENT=\"Gerry Danen\">\n"
                  " <META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n"
                  " <TITLE>%s\n </TITLE>\n</HEAD>\n"
                  "<BODY %s BGPROPERTIES=\"fixed\" TEXT=\"#%s\" BGCOLOR=\"#%s\" "
                  "LINK=\"#%s\" VLINK=\"#%s\" ALINK=\"#%s\">\n\n",
                  pgm_name, pgm_vers, tit, bg,
                  sColText, sColBG, sColLink, sColVlink, sColAlink );
}


void    max2htm_setup( char pgname[] )                                  //~~~
{
    int         done, yyyy, mm, dd ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    ansi_cls( 1, stderr );
    logon(1);

    strcpy( sLogSday , TodaysDay()   );
    strcpy( sLogSdate, TodaysCDate() );
    strcpy( sLogStime, TodaysTime()  );

    dt_getsystemdate( &sys_yyyymmdd, &yyyy, &mm, &dd );

    fl_get_pgm_def( tmplocation, "temp", "", YES );
    if ( ! strlen(tmplocation) )
    {
        fprintf( stderr, "\rEnvironment variable or global .ini entry TEMP must be specified.\n" );
        exit( GD_ERROR_CANCEL );
    }

    if ( fl_datafilename( iniFile, pgname, "ini" ) == ERROR )
    {
        fprintf( stderr, "Can't find %s...\a\n", iniFile );
        exit( GD_ERROR_CANCEL );
    }

    fl_parse_ini( iniFile, "general" , "Maximus" , sMaxHome    , &done ); // Maximus home directory
    fl_parse_ini( iniFile, "general" , "InFile"  , sInFile     , &done ); // Maximus input file name
    fl_parse_ini( iniFile, "general" , "TopDir"  , sTopDir     , &done ); // output directory for top level index
    fl_parse_ini( iniFile, "general" , "TopName" , sTopName    , &done ); // name of top level index
    fl_parse_ini( iniFile, "general" , "CountFile" , sChtml    , &done ); // name of count file

    //  now that we know the top-level dir., we can open the log file
    sprintf( fl_log, "%s\\%s.LOG", sTopDir, get_global_program_name() );
    strupr ( fl_log );
    if ( ( fLog = fopen( fl_log, "w" ) ) == NULL )
    {
        fprintf( stderr, "Cannot create log file: %s\n", fl_log );
        exit( 3 );
    }
    fprintf( fLog, "Log for %s %s - %s %s %s\n\n",
                    pgm_name, pgm_vers, TodaysDay(), TodaysCDate(), TodaysTime() );
    fprintf( stderr, "\nCheck %s for messages!\n\n", fl_log );

    fl_parse_ini( iniFile, "general" , "FilName" , sFilName    , &done ); // name of index files in each directory
    fl_parse_ini( iniFile, "general" , "Font"    , sFont       , &done ); // font name(s)
    fl_parse_ini( iniFile, "general" , "CDtitle" , sCDname     , &done ); // CD title
    fl_parse_ini( iniFile, "general" , "FileDate", sFileDateOut, &done ); // date to set on output files
    fl_parse_ini( iniFile, "general" , "FileTime", sFileTimeOut, &done ); // time to set on output files
    fl_parse_ini( iniFile, "general" , "BatFile" , fl_bat      , &done ); // batch file name
    fl_parse_ini( iniFile, "general" , "FilesBBS", cmd         , &done ); // yn files.bbs
    strupr( cmd );
    if ( cmd[0] == 'Y' || cmd[0] == '1' || cmd[0] == 'T' )
        ynFilesBBS = TRUE ;
    fl_parse_ini( iniFile, "general" , "FilesTxt", cmd         , &done ); // yn files.txt
    strupr( cmd );
    if ( cmd[0] == 'Y' || cmd[0] == '1' || cmd[0] == 'T' )
        ynFilesTXT = TRUE ;
    fl_parse_ini( iniFile, "general" , "MasterIndex", cmd      , &done ); // yn master index
    strupr( cmd );
    if ( cmd[0] == 'Y' || cmd[0] == '1' || cmd[0] == 'T' )
        ynMaster = TRUE ;

    fl_parse_ini( iniFile, "html"    , "Site"    , sSite       , &done ); // website
    fl_parse_ini( iniFile, "html"    , "DLtext"  , sDLtext     , &done ); // download textstring
    fl_parse_ini( iniFile, "html"    , "PageBG"  , sSiteBG     , &done ); // webpage background gif
    fl_parse_ini( iniFile, "html"    , "FileCase", sFileCase   , &done ); // file name case

    fl_parse_ini( iniFile, "html col", "text"    , sColText    , &done ); // regular text
    fl_parse_ini( iniFile, "html col", "link"    , sColLink    , &done ); // link
    fl_parse_ini( iniFile, "html col", "vlink"   , sColVlink   , &done ); // visited link
    fl_parse_ini( iniFile, "html col", "alink"   , sColAlink   , &done ); // active link
    fl_parse_ini( iniFile, "html col", "bgcolor" , sColBG      , &done ); // page background

    fl_parse_ini( iniFile, "MasterIndex", "name" , cmd         , &done ); // name of master index file
    sprintf( fl_master, "%s\\%s", sTopDir, cmd );

    fl_parse_ini( iniFile, "files.txt","name"    , sFilesTXT   , &done ); // files.txt name
    fl_parse_ini( iniFile, "files.bbs","name"    , sFilesBBS   , &done ); // files.bbs name
    fl_parse_ini( iniFile, "files.bbs","ldc"     , cmd         , &done ); // LD cont char
    if ( strlen(cmd) )
        cLDC = cmd[0] ;
    else
        cLDC = ' ' ;
    fl_parse_ini( iniFile, "files.bbs","ldi"     , cmd         , &done ); // LD indent
    if ( strlen(cmd) )
        nLDI = atoi(cmd);
    else
        nLDI = 0 ;

    if ( st_eq(sFileCase, "upper") )
        strcpy( sFileCase, "U" );
    else
    if ( st_eq(sFileCase, "upperlower") )
        strcpy( sFileCase, "X" );               // mixed case
    else
        strcpy( sFileCase, "L" );               // lowercase

    lFileDateOut = DateStr2ymd( sFileDateOut, DSTYP_DAT_DMY2 );
    if ( lFileDateOut < 19900101L )
         lFileDateOut = sys_yyyymmdd ;
    if ( TimeStr2Num( sFileTimeOut, 0, &lFileTimeOut ) == ERROR )
         lFileTimeOut = 0 ;

    if ( strlen(sMaxHome) )
    {
        strcat( sMaxHome, "\\" );
        strcat( sMaxHome, sInFile );
        if ( ! fl_exist( sMaxHome ) )
        {
            fprintf( stderr, "\nCannot open Maximus input file %s\n", sMaxHome );
            do_help();
        }
    }

    if ( ( fBat = fopen( fl_bat, "w" ) ) == NULL )  // batch file
    {
        fprintf( stderr, "Cannot create batch file: %s\n", fl_bat );
        exit( 3 );
    }
    fprintf( fBat, "@echo off\n\n: Generated by %s\n\n set gd.sound=N\n", get_global_program_name() );

    _getcwd( origdir, sizeof(origdir) );          // get current directory

    fprintf( fLog, "Settings:\n"
                   "  General:\n"
                   "    Maximus input file                : %s\n"
                   "    Directory to write top level index: %s\n"
                   "    Name of top level index           : %s\n"
                   "    Name index in each directory      : %s\n"
                   "  HTML:\n"
                   "    Download URL                      : %s\n"
                   "    Download text                     : %s\n"
                   "    Background graphics file          : %s\n"
                   "    File name case                    : %s\n"
                   "  HTML colours:\n"
                   "    Text                              : %s\n"
                   "    Links                             : %s\n"
                   "    Visited links                     : %s\n"
                   "    Active links                      : %s\n"
                   "    Page background                   : %s\n"
                   "\n",
                   sMaxHome, sTopDir, sTopName, sFilName,
                   sSite, sDLtext, sSiteBG, sFileCase,
                   sColText, sColLink, sColVlink, sColAlink, sColBG );

    if ( ynMaster )
    {
        if ( ( fMaster = fopen( fl_master, "w" ) ) == NULL )
        {
            fprintf( stderr, "Cannot open master index file: %s\n", fl_master );
            exit( 3 );
        }
    }
    sprintf( fl_2, "%s\\%s", sTopDir, sTopName );
    if ( ( fTop = fopen( fl_2, "w" ) ) == NULL )
    {
        fprintf( stderr, "Cannot open top level index file: %s\n", fl_2 );
        exit( 3 );
    }
    sprintf( fl_Chtml, "%s\\%s", sTopDir, sChtml );
    if ( ( fChtml = fopen( fl_Chtml, "w" ) ) == NULL )
    {
        fprintf( stderr, "Cannot open count html file: %s\n", fl_Chtml );
        exit( 3 );
    }
    fcount_head( fChtml );

    output_head( fTop, sCDname );
    fprintf( fTop, "<div align=\"center\"><center>\n"
                   "<table border=\"10\" width=\"100%%\" bgcolor=\"#FF0000\" cellspacing=\"0\" cellpadding=\"5\">\n"
                   " <tr>\n"
                   "  <td width=\"100%%\"><p align=\"center\"><font face=\"%s\" size=\"6\" color=\"#FFFF00\">\n"
                   "  <strong>%s</strong></font></td>\n"
                   " </tr>\n</table></center></div>\n\n", sFont, sCDname );
}


void    max2htm_close( void )                                           //~~~
{
    UCHAR       temp[81] ;

    strcpy( work, pgm_copyrite );
    st_get_word( temp, work );
    st_remove_word( work );

    fprintf( fTop, "\n<small><font face=\"%s\"><p><a href=\"%s\">%s</a>\n</font></small></p>\n",
                   sFont, sChtml, "To see how many files are in each directory, click here..." );

    fprintf( fTop, "\n<small><small><strong><font face=\"%s\"><p>\n"
                   "Created by %s %s on %s<br>%s %s %s.\n"
                   "</font></small></small></strong></p></body></html>\n",
                   sFont, pgm_name, pgm_vers, sFileDateOut, temp, "&copy;", work );

    fcount_end( fChtml );

    fprintf( fLog, "\nRemind user to install Verdana font for best results...\n\n"
                   "Run start: %s %s %s\n"
                   "      end: %s %s %s\n",
                   sLogSday, sLogSdate, sLogStime,
                   TodaysDay(), TodaysCDate(), TodaysTime() );

    fprintf( stderr, "\r%79s\r\n", "" );

    _fcloseall();
    set_file_information( fMaster, fl_master );
    set_file_information( fTop, fl_2 );
    set_file_information( fLog, fl_log );
    set_file_information( fBat, fl_bat );
    set_file_information( fChtml, fl_Chtml );
}


void    fa_start( STRING name )                 // start of file area   //~~~
{
    sFAdesc[0] = sFAdir[0] = EOS ;
    strcpy( sFAname, name );
}


void    fa_end( void )                          // end of file area     //~~~
{
    int         done, i=0, x ;
    unsigned    numofdrives ;
    UCHAR       hfRelative[FS_LEN]="", sFdFaID[81]="" ;
    UCHAR       sCentMsg[] = "                                                                           " ;

    _dos_setdrive( sFAdir[0] - 64, &numofdrives );
    if ( _chdir( sFAdir ) != 0 )                // go to download drive
    {
        fprintf( fLog, "\n\tERROR: cannot find directory %s...\n\n", sFAdir );
        goto done ;
    }

    sprintf( sFdFaID, "%s.%s", sFDname, sFAname );
    strupr ( sFdFaID );

    nFileCount = 0 ;

    if ( ynFilesTXT )                           // like dizzy.txt
    {
        sprintf( fl_ftxt, "%s\\%s", sFAdir, sFilesTXT );
        if ( ( fFilesTXT = fopen( fl_ftxt, "w" ) ) == NULL )
        {
            fprintf( stderr, "Could not create %s\n", fl_ftxt );
            return ;
        }
        sprintf( cmd, "%s", &sFAdir[strlen(sTopDir)+1] );
        strupr ( cmd );
        fprintf( fFilesTXT, "Directory: %-48s %s %s\n", cmd, TodaysCDate(), TodaysTime() );
        fprintf( fFilesTXT, "File Area: %s - %s\n", sFdFaID, sFAdesc );
    }

    if ( ynFilesBBS )
    {
        sprintf( fl_fbbs, "%s\\%s", sFAdir, sFilesBBS );
        if ( ( fFilesBBS = fopen( fl_fbbs, "w" ) ) == NULL )
        {
            fprintf( stderr, "Could not create %s\n", fl_fbbs );
            return ;
        }
    }

    if ( ynMaster )
    {
        x = (79 - strlen(sFAdesc)) / 2 ;
        sCentMsg[x-1] = ' ' ;
        while ( sFAdesc[i] != EOS )
            sCentMsg[x++] = sFAdesc[i++] ;

        fprintf( fMaster, "%s\n", l_r_title( sFDdesc, sFileDateOut, "Ŀ" ) );
        fprintf( fMaster, "ͻ\n" );
        fprintf( fMaster, "%s\n", sCentMsg );
        fprintf( fMaster, "ͼ\n" );
        fprintf( fMaster, "%s\n\n", l_r_title( sFdFaID, &sFAdir[strlen(sTopDir)], "" ) );
    }

    sprintf( fl_3, "%s\\%s", sFAdir, sFilName );
    fDizOut = fopen( fl_3, "w" );
    if ( fDizOut )
    {
        strcpy( hfRelative, "." );
        strcat( hfRelative, &fl_3[strlen(sTopDir)] );
        strlwr( hfRelative );
        fprintf( fTop, " <tr>\n"
                       "  <td width=\"20%%\" valign=\"middle\" align=\"left\"><a HREF=\"%s\"><b>\n"
                       "  <font face=\"%s\" size=\"2\">%s</font></b></a></td>\n"
                       "  <td width=\"80%%\" valign=\"middle\" align=\"left\"><font face=\"%s\" size=\"2\">\n"
                       "  %s</font></td>\n"
                       " </tr>\n",
                       hfRelative, sFont, sFAname, sFont, sFAdesc );

        output_head( fDizOut, sFAdesc );
        fprintf( fDizOut, "<div align=\"center\"><center>\n"
                          "<table border=\"10\" width=\"100%%\" bgcolor=\"#FF0000\" cellspacing=\"0\" cellpadding=\"5\">\n"
                          " <tr>\n"
                          "  <td width=\"100%%\"><p align=\"center\"><font face=\"%s\" size=\"4\" color=\"#FFFF00\">\n"
                          "  %s</font></td>\n"
                          " </tr>\n</table></center></div><p>&nbsp;</p>\n\n", sFont, sFAdesc );

        fprintf( stderr, "\r%79s\rDirectory %s\n", "", sFAdir );
        fprintf( fLog, "%s directory...\n", sFAdir );

        sprintf( cmd, "%s\\%s", sFAdir, fl_ziplog );
        fprintf( fBat, "\n bu y {y:5} Press Ctrl/Break to abort, or do nothing "
                       "to continue...\n if exist %s erase %s\n mk %s\n\n",
                       cmd, cmd, sFAdir );

        //  count first how many files to process and load table
        done = _dos_findfirst( sFileMask, attrib, &dta );
        while ( ! done )
        {
            ftable_update( dta.name );
            done = _dos_findnext( &dta );
        }

        qsort( (char *)ftable, (size_t)ft_entries, (size_t)sizeof(char *), qs_compare );
        for ( done=0 ; done<ft_entries ; done++ )   // now write the output file
        {
            process_file( ftable[done], done+1, ft_entries );
            free( ftable[done] );
        }
        ft_entries = 0 ;

//      fprintf( fLog, "File count for directory %s is %ld\n", sFAdir, nFileCount );

        fprintf( fChtml, " <tr VALIGN=\"middle\">\n"
                         "  <td ALIGN=\"left\" width=\"25%%\"><font face=\"%s\" size=\"2\" color=\"#FFFF00\">%s</font></td>\n"
                         "  <td ALIGN=\"left\" width=\"60%%\"><font face=\"%s\" size=\"2\" color=\"#FFFF00\">%s</font></td>\n"
                         "  <td ALIGN=\"right\" width=\"15%%\"><font face=\"%s\" size=\"2\" color=\"#FFFF00\">%ld</font></td>\n"
                         " </tr>\n",
                         sFont, &sFAdir[strlen(sTopDir)+1],
                         sFont, sFAdesc,
                         sFont, nFileCount );

        fprintf( fBat, "\n st /b /d=%s /t=%s %s >nul\n",
                       sFileDateOut, sFileTimeOut, fl_ziplog );

        fprintf( fDizOut, "<p><font face=\"%s\" size=\"2\" color=\"#FF0000\">"
                          "<strong>Use the BACK button of your browser to go back "
                          "to the previous page</strong></font></p>\n", sFont );

        set_file_information( fDizOut, fl_3 );
    }
    else
        fprintf( stderr, "Could not create %s\n", fl_3 );

    if ( ynFilesTXT )
        set_file_information( fFilesTXT, fl_ftxt );

    if ( ynFilesBBS )
        set_file_information( fFilesBBS, fl_fbbs );

done:
    _dos_setdrive( origdir[0] - 64, &numofdrives );
    _chdir( origdir );                           // back to original
    sFAname[0] = sFAdesc[0] = sFAdir[0] = EOS ;
}


void    fd_start( STRING name, STRING xtra )    // start of division    //~~~
{
    UCHAR       sCentMsg[] = "" ;
    int         i=0, x ;

    sFDname[0] = sFDdesc[0] = EOS ;
    strcpy( sFDname, name );
    st_remove_word( xtra );
    st_remove_word( xtra );
    st_remove_word( xtra );
    strcpy( sFDdesc, xtra );

    if ( ynMaster )
    {
        x = (79 - strlen(sFDdesc)) / 2 ;
        sCentMsg[x-1] = ' ' ;
        while ( sFDdesc[i] != EOS )
            sCentMsg[x++] = sFDdesc[i++] ;
        sCentMsg[x++] = ' ' ;
        strupr ( sCentMsg );
        fprintf( fMaster, "\n" );
        fprintf( fMaster, "%s\n", sCentMsg );
        fprintf( fMaster, "\n\n" );
    }

    fprintf( fTop, "<div align=\"center\"><center><small><small><p>&nbsp;<br></small></small>\n"
                   "<table border=\"6\" width=\"100%%\" bgcolor=\"#800080\" cellpadding=\"4\" cellspacing=\"0\">\n"
                   " <tr>\n"
                   "  <td width=\"100%%\" valign=\"middle\" align=\"left\"><p align=\"left\">\n"
                   "  <font face=\"%s\" size=\"5\" color=\"#00FFFF\"><b>\n"
                   "  %s</b></font></td>\n"
                   " </tr>\n</table></center></div>\n\n",
                   sFont, sFDdesc );
    fprintf( fTop, "<div align=\"center\"><center>\n"
                   "<table border=\"2\" width=\"100%%\" cellspacing=\"0\" cellpadding=\"2\" bgcolor=\"#000080\">\n" );
}


void    fd_end( void )                          // end of file division //~~~
{
    fprintf( fTop, "</table></center></div>\n\n" );
}


void    process_input_file( void )                                      //~~~
{
    UCHAR buf[1024] ;

    if ( ( fMaxIn = fopen( sMaxHome, "r" ) ) == NULL )
    {
        fprintf( stderr, "Cannot open input file: %s\n", sMaxHome );
        exit( 3 );
    }

    while ( fgets( buf, (sizeof(buf)-1), fMaxIn ) )  // read filearea.ctl
    {
        st_trim( buf );
        if ( strlen(buf) )
        {
            st_get_word( work, buf );
            st_remove_word( buf );
            if ( st_eq( work, "FileDivisionEnd" ) )
                fd_end();

            if ( st_eq( work, "End" ) )
            {
                st_get_word( work, buf );
                if ( st_eq( work, "FileArea" ) )
                    fa_end();
                ST_CLR( work );
                ST_CLR( buf  );
            }

            if ( st_eq( work, "FileDivisionBegin" ) )
            {
                st_get_word( work, buf );
                fd_start( work, buf );
            }
            if ( st_eq( work, "FileArea" ) )
            {
                st_get_word( work, buf );
                fa_start( work );
            }
            if ( st_eq( work, "Desc" ) )
            {
                ST_CPY( sFAdesc, buf );
            }
            if ( st_eq( work, "Download" ) )
            {
                st_get_word( work, buf );
                if ( ST_LASTCHAR(work) == '\\' )
                    ST_CLR_LASTCHAR(work);
                ST_CPY( sFAdir, work );
                strupr( sFAdir );
            }
        }
    }
// done:
    fclose( fMaxIn );
}


void    main( int argc, char *argv[] )
{
    max2htm_setup( argv[0] );
    process_input_file();
    max2htm_close();
    exit( 0 );
}                                                                       // 
